\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{eskdagrlist}[Agreed List]

\RequirePackage{eskdstamp}
\RequirePackage{etoolbox}

%---------------------------------------------------------------

\newcommand\ESKDagrlistMakeStamp[2]{#1 & @ESKD-agrlist-fill@ & #2 @ESKD-agrlist-tabularnewline@}

\newcommand\ESKD@agrlist@make[3]{\@nameuse{ESKD@agrlist@#1@#2@#3}}
\newcommand{\ESKD@agrlist@make@stamp}[2]{%
  \ESKDagrlistMakeStamp%
  {\@nameuse{ESKD@agrlist@#1@post@#2}}%
  {\@nameuse{ESKD@agrlist@#1@name@#2}}}

\def\ESKD@agrlist@post@Width{3.6in}
\def\ESKDagrListPostWidth#1{\def\ESKD@agrlist@post@Width{#1}}

\def\ESKD@agrlist@stamp@Width{0.8in}
\def\ESKDagrListStampWidth#1{\def\ESKD@agrlist@stamp@Width{#1}}

\def\ESKD@agrlist@name@Width{1.6in}
\def\ESKDagrListNameWidth#1{\def\ESKD@agrlist@name@Width{#1}}

\def\ESKDagrListStyle{%
  \linespread{\ESKD@table@linespread}\selectfont
  \setlength{\tabcolsep}{2ex}
  \renewcommand{\arraystretch}{1.0}
  \centering
  \hyphenpenalty=10000
}

\newcommand\ESKD@agrlist@makelist[1]{\ifnum \@nameuse{ESKD@agrlist@#1@cnt} > 0
  \edef\ESKD@mylines{}
  \ESKD@tmpcnta = 0
  \loop\ifnum \ESKD@tmpcnta < \@nameuse{ESKD@agrlist@#1@cnt}
  \advance \ESKD@tmpcnta 1
  \edef\ESKD@mylines{%
    \ESKD@mylines
    \ESKD@agrlist@make@stamp{#1}{\number\ESKD@tmpcnta}
  }
  \repeat
  \ESKD@tmpcnta = 1
  \loop\ifnum \ESKD@tmpcnta > 0
    \patchcmd{\ESKD@mylines}{@ESKD-agrlist-tabularnewline@}{\\\cline{2-2}}{}{\ESKD@tmpcnta = 0}
  \repeat
  \ESKD@tmpcnta = 1
  \loop\ifnum \ESKD@tmpcnta > 0
    \patchcmd{\ESKD@mylines}{@ESKD-agrlist-fill@}{\ \newline\ \newline\ }{}{\ESKD@tmpcnta = 0}
  \repeat
  \iffalse % для отладки
  \show\ESKD@mylines
  \errmessage{debug}
  \fi
  \begingroup
  \ESKDagrListStyle
  \begin{tabular}{>{\raggedright}b{\ESKD@agrlist@post@Width} b{\ESKD@agrlist@stamp@Width} b{\ESKD@agrlist@name@Width}}
    \ESKD@mylines
  \end{tabular}
  \endgroup
  \fi}

%---------------------------------------------------------------

\newcount\ESKD@agrlist@checkers@cnt
\ESKD@agrlist@checkers@cnt = 0

\newcommand{\ESKDagrlistCheckedBy}[2]{%
  \advance \ESKD@agrlist@checkers@cnt 1
  \@namedef{ESKD@agrlist@checkers@post@\number\ESKD@agrlist@checkers@cnt}{#1}
  \@namedef{ESKD@agrlist@checkers@name@\number\ESKD@agrlist@checkers@cnt}{#2}}

\newcommand{\ESKDcheckersList}{\ESKD@agrlist@makelist{checkers}}

\newcount\ESKD@agrlist@authors@cnt
\ESKD@agrlist@authors@cnt = 0

\newcommand{\ESKDagrlistDesignedBy}[2]{%
  \advance \ESKD@agrlist@authors@cnt 1
  \@namedef{ESKD@agrlist@authors@post@\number\ESKD@agrlist@authors@cnt}{#1}
  \@namedef{ESKD@agrlist@authors@name@\number\ESKD@agrlist@authors@cnt}{#2}}

\newcommand{\ESKDauthorsList}{\ESKD@agrlist@makelist{authors}}
